'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = wrapCustomMethod;

var _Event = require('../base/Event');

var _Event2 = _interopRequireDefault(_Event);

var _isPromise = require('./isPromise');

var _isPromise2 = _interopRequireDefault(_isPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function wrapCustomMethod(context, methodName, func) {
  return function () {
    context.trigger('method:call', new _Event2.default({ path: [methodName] }));

    var changed = false;
    var watcher = context.on('change', function () {
      changed = true;
    });

    var result = func.bind(context).apply(undefined, arguments);

    // sync
    if (!(0, _isPromise2.default)(result)) {
      watcher();

      if (changed) {
        context.trigger('method:change', new _Event2.default({
          path: [methodName]
        }));
      }

      return result;
    }

    // async
    return result.then(function (promiseResult) {
      watcher();

      if (changed) {
        context.trigger('method', new _Event2.default({
          path: [methodName]
        }));
      }

      return promiseResult;
    });
  };
}